package model;

public class ArbitreConwayStyle extends Arbitre{

	public ArbitreConwayStyle(Plateau plateau, Regles regle) {
		super(plateau, regle);
	}

	@Override
	public CellState VerifierChangementCellules(int x, int y) {
		if(verifierNaissance(x, y)) {
			return CellState.BIRTH;
		}
		if(verifierMort(x, y)) {
			return CellState.DIE;
		}
		return plateau.getCell(x, y).estAlive() ? CellState.LIVE : CellState.DIE;
	}

	private boolean verifierNaissance(int x, int y) {
		int cpt = compterNbCellAutour(x, y);
		if(cpt == 3 && !plateau.getCell(x, y).estAlive()) {
			return true;
		}
		return false;
	}

	private boolean verifierMort(int x, int y) {
		int cpt = compterNbCellAutour(x, y);
		if(!(cpt == 2 || cpt == 3) && plateau.getCell(x, y).estAlive()) {
			return true;
		}
		return false;
	}

	private int compterNbCellAutour(int x, int y)
	{
		int cpt = 0;
		if(plateau.getCell(x-1, y-1).estAlive())
		{
			++cpt;
		}
		if(plateau.getCell(x, y-1).estAlive())
		{
			++cpt;
		}
		if(plateau.getCell(x+1, y-1).estAlive())
		{
			++cpt;
		}
		if(plateau.getCell(x+1, y).estAlive())
		{
			++cpt;
		}
		if(plateau.getCell(x+1, y+1).estAlive())
		{
			++cpt;
		}
		if(plateau.getCell(x, y+1).estAlive())
		{
			++cpt;
		}
		if(plateau.getCell(x-1, y+1).estAlive())
		{
			++cpt;
		}
		if(plateau.getCell(x-1, y).estAlive())
		{
			++cpt;
		}
		return cpt;
	}
}
