package model;

import javafx.beans.property.BooleanProperty;
import javafx.beans.property.ReadOnlyBooleanProperty;

public class Cellule {
    private int x;
    private int y;
    private BooleanProperty alive;

    public Cellule(int x, int y) throws IllegalArgumentException {
        setX(x);
        setY(y);
    }

    public Boolean estAlive() { return alive.get(); }
    public void setAlive(Boolean alive) { this.alive.set(alive); }
    public ReadOnlyBooleanProperty aliveProperty() { return alive; }

    public int getX() { return x; }
    public void setX(int valeur) throws IllegalArgumentException{
        if(valeur<0) {
            throw new IllegalArgumentException("La valeur de X doit être positive");
        }
        x = valeur;
    }

    public int getY() { return y; }
    public void setY(int valeur) throws IllegalArgumentException{
        if(valeur<0) {
            throw new IllegalArgumentException("La valeure de Y doit être positive");
        }
        y = valeur;
    }

    @Override
    public boolean equals(Object o) {
        if (o == null) return false;
        if (o == this) return true;
        if (o.getClass() != this.getClass()) return false;

        if (y == ((Cellule) o).getY() && x == ((Cellule) o).getX() && estAlive() == ((Cellule) o).estAlive()) {
            return true;
        }
        return false;
    }
}
