package model;

import java.util.List;

public abstract class ObservableBDJ {
	private List<Observer> observeurs;
	public void attacher(Observer o) {
		observeurs.add(o);
	}

	public void detacher(Object o) throws IllegalArgumentException{
		if(o.getClass() != Observer.class) {
			throw new IllegalArgumentException("Imposible de détacher autre chose qu'un observer");
		}
		observeurs.remove(o);
	}

	public void notifier() {
		for (Observer observeur : observeurs) {
			observeur.update();
		}
	}
}