package views;

import javafx.fxml.FXML;
import javafx.scene.control.ColorPicker;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.layout.GridPane;
import javafx.scene.paint.Paint;
import javafx.scene.shape.Rectangle;
import javafx.util.converter.NumberStringConverter;
import model.Cellule;
import model.Plateau;

public class VueJeu {
    @FXML
    private GridPane map;

    @FXML
    private ColorPicker color;

    @FXML
    private TextField rowGame;

    @FXML
    private TextField colGame;

    @FXML
    private Label nbRowGame;

    @FXML
    private Label nbColGame;

    private Plateau plat = new Plateau();

    private void createGrid() {
        if (plat.getLongueur() > 100) {
            plat.setLongueur(100);
        }
        if (plat.getLargeur() > 80) {
            plat.setLargeur(80);
        }
        map.getChildren().clear();
        for(int i=0; i < plat.getLongueur(); ++i){
            for(int j=0; j < plat.getLargeur(); ++j) {
                map.add(new Rectangle(10, 10, Paint.valueOf("#AABBCC")), i, j);
                Cellule cell = new Cellule(i,j);
            }
        }
    }

    @FXML
    private void changeColor() {
        ((Rectangle)map.getChildren().get(4)).setFill(color.getValue());
    }

    public void initialize() {
        rowGame.textProperty().bindBidirectional(plat.longueurProperty(), new NumberStringConverter());
        colGame.textProperty().bindBidirectional(plat.largeurProperty(), new NumberStringConverter());

        createGrid();

        nbColGame.setText(colGame.getText());
        nbRowGame.setText(rowGame.getText());
    }
}
